% script l1test
% sets up dummy regression problems with pathological noise
% noise is a uniform times a lognormal, to compare minimum
% l_1-norm regression via linear programming and iteratively
% reweighted least squares.
%
% parameters
ndat = 100;			% number of data
snr = 5;			% signal to noise ratio
bdim = 5;			% dimension of model
ftype = 'bldCheb';		% subroutine to build design matrix
nboot = 100;			% number of bootstrap replications


x = [1:ndat];
X = feval(ftype,ndat,bdim-1);	% build design matrix

% generate random b
b = 10*randn(bdim,1);		% normal (for now)

yt = X*b;
normy = norm(yt);		% nominal signal level
y = yt + 2*normy/snr*(rand(size(yt))-0.5).*exp(randn(size(yt)));

figure
plot(x,yt,'g')
hold
plot(x,y,'r+')

[bl1, l1res, l1msft] = l1rgres(y,X,0,'lp');
[b2, res2, se2 ] = irwls(y,X,'l1wght',3,'one-step');
[bols, resols, wssols] = wls(y, X, ones(ndat,1)); % OLS

plot(x, X*bl1,'m')
plot(x, X*b2,'y')
plot(x, X*bols,'w')

